#include "config.h"
#include "version.h"
#include <history.h>

//  in UTF-8
#define PLUS_MINUS_UTF8 "\xC2\xB1"

GLOBAL_CONFIG_VAR_STRING(cfg_titleformat_history, HISTORY_TITLEFORMAT_PREFIX "History", 
	"$num(%_history_number%,3)"
	"$if(%_history_prev%,-$num(%_history_prev%,3),"
	"$if(%_history_next%,+$num(%_history_next%,3),"
	"$if(%_history_is_playing%," PLUS_MINUS_UTF8 "000,))). \r\n"
	"[%artist% - ]$if(%title%,['['%album%[ #[%disc%/]$num(%tracknumber%,2)]'] ']%title%,%_filename_ext%)"
	);
GLOBAL_CONFIG_VAR_STRING(cfg_titleformat_statusbar, HISTORY_TITLEFORMAT_PREFIX "Status bar", 
	"$num(%_history_number%,3)'. '\r\n"
	"$ifgreater(%_history_days_ago%,6,%_history_date%,\r\n"
	"$ifgreater(%_history_days_ago%,1,last $select(%_history_day_of_week%,Sunday,Monday,Tuesday,Wednesday,Thursday,Friday,Saturday),\r\n"
	"$ifgreater(%_history_days_ago%,0,yesterday,today)))' '\r\n"
	"$left(%_history_time%,5)"
	);
GLOBAL_CONFIG_VAR_STRING(cfg_titleformat_popup, HISTORY_TITLEFORMAT_PREFIX "Popup", 
	"[%artist% - ]$if(%title%,['['%album%[ #[%disc%/]$num(%tracknumber%,2)]'] ']%title%,%_filename_ext%)"
	);

GLOBAL_CONFIG_VAR_INT(cfg_color_text, HISTORY_COLOR_PREFIX "Text", GetSysColor(COLOR_WINDOWTEXT));
GLOBAL_CONFIG_VAR_INT(cfg_color_sel_text, HISTORY_COLOR_PREFIX "Selected text", GetSysColor(COLOR_HIGHLIGHTTEXT));
GLOBAL_CONFIG_VAR_INT(cfg_color_bg, HISTORY_COLOR_PREFIX "Background", GetSysColor(COLOR_WINDOW));
GLOBAL_CONFIG_VAR_INT(cfg_color_sel_bg, HISTORY_COLOR_PREFIX "Selected background", GetSysColor(COLOR_HIGHLIGHT));
GLOBAL_CONFIG_VAR_INT(cfg_color_frame, HISTORY_COLOR_PREFIX "Active item frame", GetSysColor(COLOR_ACTIVEBORDER));

cfg_int cfg_toggle_ascending("ascending", 1);

cfg_int cfg_toggle_change_selection("change selection", 0);

cfg_int cfg_max_size("max size",1000);

cfg_int cfg_toggle_save_history("save history",1);

cfg_int cfg_toggle_log_mode("log mode",0);

inline static uLOGFONT get_def_font()
{
	uLOGFONT foo;
	uGetDefaultFont(&foo);
	return foo;
}

GLOBAL_CONFIG_VAR_STRUCT(uLOGFONT, cfg_font_history, HISTORY_FONT_PREFIX "History", get_def_font());

cfg_int cfg_max_popup_size("max popup size", 10);

cfg_int cfg_toggle_sys_colors("use system colors", 1);
cfg_int cfg_toggle_sys_font("use system font", 1);
cfg_int cfg_toggle_sys_frame("use system frame", 1);

static color_table def_color_table = {
	{
		0xFFFFFF,0xFFFFFF,0xFFFFFF,0xFFFFFF,
		0xFFFFFF,0xFFFFFF,0xFFFFFF,0xFFFFFF,
		0xFFFFFF,0xFFFFFF,0xFFFFFF,0xFFFFFF,
		0xFFFFFF,0xFFFFFF,0xFFFFFF,0xFFFFFF,
	},
};

cfg_struct_t<color_table> cfg_color_table("color table", def_color_table);

DECLARE_COMPONENT_VERSION(COMPONENT_NAME,COMPONENT_VERSION,ABOUT_MESSAGE);
