#ifndef FOO_HISTORY_HISTORY_LOADER_H
#define FOO_HISTORY_HISTORY_LOADER_H

#include <history.h>

class NOVTABLE history_loader_callback
{
public:
	// @param info contains only history specific data
	virtual void on_entry(const file_info * info) = 0;
};

class NOVTABLE history_loader : public service_base
{
public:
	virtual const char * get_extension() = 0;
	virtual int read(const char * filename, reader * r, history_loader_callback * callback) = 0;
	virtual int write(const char * filename, reader * r, ptr_list_base< history_handle > & data) = 0;
	virtual bool can_write() = 0;

	static const GUID class_guid;
	static inline const GUID & get_class_guid() {return class_guid;}

	static const GUID
		guid_file_format_v1,
		guid_file_format_v2
		;
};

#if 0
class history_loader_v1 : public history_loader
{
};

class history_loader_v2 : public history_loader
{
};
#endif

#endif /* !FOO_HISTORY_HISTORY_LOADER_H */
