#include "history_panel.h"

#include "config.h"
#include "resource.h"

#include <imp_helper.h>

void history_panel::set_status_text(const char * text, bool is_menu) {
	if (host != NULL && is_menu) {
		if (text == NULL || *text == '\0') {
			host->restore_status_text();
		} else {
			host->override_status_text(text);
		}
	}
}

BOOL history_panel::on_destroy(WPARAM wp, LPARAM lp) {
	history_dialog_base::on_destroy(wp, lp);

	delete this;

	return TRUE;
}

HWND history_panel::g_create(HWND parent, ui_extension_host * p_host) {
	history_panel * _this = new history_panel(p_host);
	return _this->run_modeless(IDD_HISTORY_PANEL, parent);
}

class sidebar_extension_history : public ui_extension_base_t< ui_extension_flag::TYPE_PANEL, UEM_MULTIPLE > {
public:
	static const GUID extension_guid;

	virtual const GUID & get_extension_guid() const {
		return extension_guid;
	}

	virtual void get_name(string_base & out) const {
		out = "History";
	}

	virtual void get_category(string_base & out) const {
		out = "Panels";
	}

	virtual HWND create_window(HWND wnd_parent) {
		return history_panel::g_create(wnd_parent, host);
	}
};

// {E768CF9B-BC23-4a90-AAFA-19B9461F0485}
const GUID sidebar_extension_history::extension_guid = 
{ 0xe768cf9b, 0xbc23, 0x4a90, { 0xaa, 0xfa, 0x19, 0xb9, 0x46, 0x1f, 0x4, 0x85 } };

static ui_extension_factory< sidebar_extension_history > foo_sidebar_panel;
