#include "../SDK/foobar2000.h"
#include "../helpers/helpers.h"
#include "../foosion_helpers/helpers.h"
#include <history.h>
#include "resource.h"
#include "config.h"
#include "history_dialog.h"

//////////////////////////////////////////////////
// #define's for debugging features
//////////////////////////////////////////////////

//////////////////////////////////////////////////
// menu commands
//////////////////////////////////////////////////

void show_help()
{
	string8 path;
	path.set_string(core_api::get_my_full_path());
	path.truncate(path.scan_filename());
	path.add_string("foo_history_help.html");
	uShellExecute(core_api::get_main_window(), "open", path, 0, 0, SW_SHOWNORMAL);
}

class main_menu_item_history : public menu_item_main {
	virtual unsigned get_num_items() {
		return 5;
	}

	virtual void enum_item(unsigned n, string_base & out) {
		static const char * strings[] = {
			"Playback/History/Previous in history",
			"Playback/History/Next in history",
			"Playback/History/Clear history",
			"Components/History",
			"Components/History help",
		};

		if (n < get_num_items()) out = strings[n];
	}

	virtual bool get_description(unsigned n, string_base & out) {
		static const char * strings[] = {
			"Goes back by one track in the history.",
			"Goes forward by one track in the history.",
			"Clears the history.",
			"Shows the history window.",
			"Opens the history help file.",
		};

		if (n < get_num_items()) {
			out = strings[n];
			return true;
		}
		return false;
	}

	virtual enabled_state get_enabled_state(unsigned n) {
		if (n == 4) return DEFAULT_OFF;
		return DEFAULT_ON;
	}

	virtual void perform_command(unsigned n) {
		if (n-- == 0) {
			// previous in history
			if (!cfg_toggle_log_mode)
			{
				history::get()->play_item_by_offset(-1);
			}
		} else if (n-- == 0) {
			// next in history
			if (!cfg_toggle_log_mode)
			{
				if (!history::get()->play_item_by_offset(+1))
				{
					play_control::get()->play_start(play_control::TRACK_COMMAND_DEFAULT);
				}
			}
		} else if (n-- == 0) {
			// reset history
			history * h = history::get();
			if (h) h->remove_all();
		} else if (n-- == 0) {
			// show history window
			dialog_history::g_activate();
		} else if (n-- == 0) {
			show_help();
		}
	}
};

static menu_item_factory< main_menu_item_history > foo_menu_item;
