#if !defined(FOO_HISTORY__PREFS_H)
#define FOO_HISTORY__PREFS_H

#include "../SDK/foobar2000.h"
#include <history.h>

#include "../foosion_helpers/helpers.h"

typedef HWND (*create_config_page_func_t)(HWND parent);

struct config_page_desc_t {
	const char * name;
	create_config_page_func_t create;
};

class dialog_config : dialog_base {
private:
	HWND wnd_tab;
	HWND wnd_page;

	mem_block_list_t<HWND> wnd_page_list;

	dialog_config();

	BOOL on_message(UINT msg, WPARAM wp, LPARAM lp);
	BOOL on_notify(NMHDR * pnm);

	void init_tabs();
	void change_tab();

public:
	static HWND create(HWND parent);
};

class dialog_page_titleformat : dialog_base {
private:
	config_var_string * current_format;
	history_handle * handle;

	dialog_page_titleformat();

	BOOL on_message(UINT msg, WPARAM wp, LPARAM lp);
	void on_text_changed();
	void save_text();

	void show_insert_format_menu();

public:
	static HWND create(HWND parent);
};

class dialog_page_display : dialog_base {
private:
	HBRUSH brush_sample1;
	HBRUSH brush_sample2;

	dialog_page_display();

	BOOL on_message(UINT msg, WPARAM wp, LPARAM lp);

	bool edit_color(int n);
	bool edit_font(config_var_struct< uLOGFONT > & var);
	void get_font_description(const uLOGFONT & font, string_base & out);

	void set_element(int elt_idx);

	void on_font_changed();
	void on_color_changed(int n);

public:
	static HWND create(HWND parent);
};

class dialog_page_history : dialog_base {
private:
	dialog_page_history();

	BOOL on_message(UINT msg, WPARAM wp, LPARAM lp);

public:
	static HWND create(HWND parent);
};


#endif /* !defined(FOO_HISTORY__PREFS_H) */
