#include "../SDK/foobar2000.h"
#include "../foosion_helpers/helpers.h"
#include <history.h>
#include <dbsearch.h>
#include "config.h"
#include "prefs.h"
#include "resource.h"

HWND dialog_page_history::create(HWND parent) {
	dialog_page_history * ptr = new dialog_page_history();
	return ptr->run_modeless(IDD_CFGPAGE_HISTORY, parent);
}

dialog_page_history::dialog_page_history() {
}

BOOL dialog_page_history::on_message(UINT msg, WPARAM wp, LPARAM lp) {
	static config_var_string * current_format;
	static const file_info *info;

	switch(msg)
	{

	case WM_INITDIALOG:
		{
			uSendDlgItemMessage(wnd, IDC_CHANGESEL, BM_SETCHECK, cfg_toggle_change_selection, 0);
			uSendDlgItemMessage(wnd, IDC_SAVEHISTORY, BM_SETCHECK, cfg_toggle_save_history, 0);
			SetDlgItemInt(wnd, IDC_MAXSIZE, cfg_max_size, 0);
			uSendDlgItemMessage(wnd, IDC_LOGMODE, BM_SETCHECK, cfg_toggle_log_mode, 0);
		}
		break;

	case WM_DESTROY:
		{
			delete this;
		}
		break;

	case WM_COMMAND:
		{
			switch (wp) {

			case IDC_MAXSIZE | (EN_KILLFOCUS<<16):
				{
					BOOL translated;
					unsigned max_size = GetDlgItemInt(wnd,IDC_MAXSIZE,&translated,0);
					if (translated) cfg_max_size = max_size;
				}
				break;

			case IDC_CHANGESEL | (BN_CLICKED<<16):
				{
					cfg_toggle_change_selection = uSendMessage((HWND)lp, BM_GETCHECK, 0, 0)==BST_CHECKED;
				}
				break;

			case IDC_SAVEHISTORY | (BN_CLICKED<<16):
				{
					cfg_toggle_save_history = uSendMessage((HWND)lp, BM_GETCHECK, 0, 0)==BST_CHECKED;
				}
				break;

			case IDC_LOGMODE | (BN_CLICKED<<16):
				{
					cfg_toggle_log_mode = uSendMessage((HWND)lp, BM_GETCHECK, 0, 0)==BST_CHECKED;
				}
				break;

			case IDC_CLEAR:
				{
					history::get()->remove_all();
				}
				break;
			}
		}
		break;

	default:
		return FALSE;
		break;
	}

	return TRUE;
}
